import { coerceBooleanProperty } from '@angular/cdk/coercion';
import * as i0 from '@angular/core';
import { EventEmitter, Directive, Input, Output, HostListener, NgModule, Component, ContentChild } from '@angular/core';
import * as i1 from '@angular/common';
import { CommonModule } from '@angular/common';

class ButtonDirective {
    constructor(_element, _renderer) {
        this._element = _element;
        this._renderer = _renderer;
        this._disabled = false;
        this.size = 'default';
        this.kind = 'primary';
        this.safeClick = new EventEmitter();
    }
    get disabled() { return this._disabled; }
    set disabled(value) {
        debugger;
        this._disabled = coerceBooleanProperty(value);
    }
    ngOnInit() {
        this._renderer.addClass(this._element.nativeElement, 'btn');
    }
    _onClick(e) {
        if (!this.disabled) {
            this.safeClick.emit(e);
        }
    }
}
ButtonDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.1", ngImport: i0, type: ButtonDirective, deps: [{ token: i0.ElementRef }, { token: i0.Renderer2 }], target: i0.ɵɵFactoryTarget.Directive });
ButtonDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.1.1", type: ButtonDirective, selector: "button[jssButton], a[jssButton], input[jssButton]", inputs: { size: "size", kind: "kind" }, outputs: { safeClick: "safeClick" }, host: { listeners: { "click": "_onClick($event)" }, properties: { "class.disabled": "disabled", "class.btn-primary": "!outline && kind==\"primary\"", "class.btn-secondary": "!outline && kind==\"secondary\"", "class.btn-success": "!outline && kind==\"success\"", "class.btn-danger": "!outline && kind==\"danger\"", "class.btn-warning": "!outline && kind==\"warning\"", "class.btn-info": "!outline && kind==\"info\"", "class.btn-light": "!outline && kind==\"light\"", "class.btn-dark": "!outline && kind==\"dark\"", "class.btn-link": "kind==\"link\"", "class.btn-outline-primary": "outline && kind==\"primary\"", "class.btn-outline-secondary": "outline && kind==\"secondary\"", "class.btn-outline-success": "outline && kind==\"success\"", "class.btn-outline-danger": "outline && kind==\"danger\"", "class.btn-outline-warning": "outline && kind==\"warning\"", "class.btn-outline-info": "outline && kind==\"info\"", "class.btn-outline-light": "outline && kind==\"light\"", "class.btn-outline-dark": "outline && kind==\"dark\"", "class.btn-sm": "size==\"small\"", "class.btn-lg": "size==\"large\"", "prop.disabled": "disabled", "attr.aria-disabled": "disabled", "attr.tabindex": "disabled ? \"-1\" : \"\" " } }, exportAs: ["jssButton"], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.1", ngImport: i0, type: ButtonDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'button[jssButton], a[jssButton], input[jssButton]',
                    exportAs: 'jssButton',
                    host: {
                        '[class.disabled]': 'disabled',
                        '[class.btn-primary]': '!outline && kind=="primary"',
                        '[class.btn-secondary]': '!outline && kind=="secondary"',
                        '[class.btn-success]': '!outline && kind=="success"',
                        '[class.btn-danger]': '!outline && kind=="danger"',
                        '[class.btn-warning]': '!outline && kind=="warning"',
                        '[class.btn-info]': '!outline && kind=="info"',
                        '[class.btn-light]': '!outline && kind=="light"',
                        '[class.btn-dark]': '!outline && kind=="dark"',
                        '[class.btn-link]': 'kind=="link"',
                        '[class.btn-outline-primary]': 'outline && kind=="primary"',
                        '[class.btn-outline-secondary]': 'outline && kind=="secondary"',
                        '[class.btn-outline-success]': 'outline && kind=="success"',
                        '[class.btn-outline-danger]': 'outline && kind=="danger"',
                        '[class.btn-outline-warning]': 'outline && kind=="warning"',
                        '[class.btn-outline-info]': 'outline && kind=="info"',
                        '[class.btn-outline-light]': 'outline && kind=="light"',
                        '[class.btn-outline-dark]': 'outline && kind=="dark"',
                        '[class.btn-sm]': 'size=="small"',
                        '[class.btn-lg]': 'size=="large"',
                        '[prop.disabled]': 'disabled',
                        '[attr.aria-disabled]': 'disabled',
                        '[attr.tabindex]': 'disabled ? "-1" : "" ',
                    }
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.Renderer2 }]; }, propDecorators: { size: [{
                type: Input
            }], kind: [{
                type: Input
            }], safeClick: [{
                type: Output
            }], _onClick: [{
                type: HostListener,
                args: ['click', ['$event']]
            }] } });

class ButtonModule {
}
ButtonModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.1", ngImport: i0, type: ButtonModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
ButtonModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.1", ngImport: i0, type: ButtonModule, declarations: [ButtonDirective], exports: [ButtonDirective] });
ButtonModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.1", ngImport: i0, type: ButtonModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.1", ngImport: i0, type: ButtonModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        ButtonDirective,
                    ],
                    exports: [
                        ButtonDirective,
                    ]
                }]
        }] });

class CardFooterDirective {
    constructor(templateRef) {
        this.templateRef = templateRef;
    }
}
CardFooterDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.1", ngImport: i0, type: CardFooterDirective, deps: [{ token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive });
CardFooterDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.1.1", type: CardFooterDirective, selector: "[jssCardFooter]", exportAs: ["jssCardFooter"], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.1", ngImport: i0, type: CardFooterDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[jssCardFooter]',
                    exportAs: 'jssCardFooter',
                }]
        }], ctorParameters: function () { return [{ type: i0.TemplateRef }]; } });

class CardHeaderDirective {
    constructor(templateRef) {
        this.templateRef = templateRef;
    }
}
CardHeaderDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.1", ngImport: i0, type: CardHeaderDirective, deps: [{ token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive });
CardHeaderDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.1.1", type: CardHeaderDirective, selector: "[jssCardHeader]", exportAs: ["jssCardHeader"], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.1", ngImport: i0, type: CardHeaderDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[jssCardHeader]',
                    exportAs: 'jssCardHeader',
                }]
        }], ctorParameters: function () { return [{ type: i0.TemplateRef }]; } });

class CardComponent {
    constructor(_element, _renderer) {
        this._element = _element;
        this._renderer = _renderer;
    }
    ngOnInit() {
        this._renderer.addClass(this._element.nativeElement, 'card');
    }
}
CardComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.1", ngImport: i0, type: CardComponent, deps: [{ token: i0.ElementRef }, { token: i0.Renderer2 }], target: i0.ɵɵFactoryTarget.Component });
CardComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.1", type: CardComponent, selector: "jss-card", queries: [{ propertyName: "_header", first: true, predicate: CardHeaderDirective, descendants: true }, { propertyName: "_footer", first: true, predicate: CardFooterDirective, descendants: true }], exportAs: ["jssCard"], ngImport: i0, template: "<div *ngIf=\"_header\" class=\"card-header\">\r\n    <ng-container [ngTemplateOutlet]=\"_header.templateRef\"></ng-container>\r\n</div>\r\n\r\n<div class=\"card-body\">\r\n    <ng-content></ng-content>\r\n</div>\r\n\r\n<div *ngIf=\"_footer\" class=\"card-footer\">\r\n    <ng-container [ngTemplateOutlet]=\"_footer.templateRef\"></ng-container>\r\n</div>\r\n", styles: [":host{display:block}\n"], dependencies: [{ kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.1", ngImport: i0, type: CardComponent, decorators: [{
            type: Component,
            args: [{ selector: 'jss-card', exportAs: 'jssCard', template: "<div *ngIf=\"_header\" class=\"card-header\">\r\n    <ng-container [ngTemplateOutlet]=\"_header.templateRef\"></ng-container>\r\n</div>\r\n\r\n<div class=\"card-body\">\r\n    <ng-content></ng-content>\r\n</div>\r\n\r\n<div *ngIf=\"_footer\" class=\"card-footer\">\r\n    <ng-container [ngTemplateOutlet]=\"_footer.templateRef\"></ng-container>\r\n</div>\r\n", styles: [":host{display:block}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.Renderer2 }]; }, propDecorators: { _header: [{
                type: ContentChild,
                args: [CardHeaderDirective]
            }], _footer: [{
                type: ContentChild,
                args: [CardFooterDirective]
            }] } });

const DECLARES = [
    CardComponent,
    CardFooterDirective,
    CardHeaderDirective
];
class CardModule {
}
CardModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.1", ngImport: i0, type: CardModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
CardModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.1", ngImport: i0, type: CardModule, declarations: [CardComponent,
        CardFooterDirective,
        CardHeaderDirective], imports: [CommonModule], exports: [CardComponent,
        CardFooterDirective,
        CardHeaderDirective] });
CardModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.1", ngImport: i0, type: CardModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.1", ngImport: i0, type: CardModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule
                    ],
                    declarations: DECLARES,
                    exports: DECLARES
                }]
        }] });

export { ButtonDirective, ButtonModule, CardComponent, CardFooterDirective, CardHeaderDirective, CardModule };
//# sourceMappingURL=js-sugar-angular-bootstrap.mjs.map
